
_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68

;BusPirate.c,87 :: 		void main() {
;BusPirate.c,90 :: 		Delay_ms(2000);                                                             // prevent multi-start when programming
	PUSH	W10
	PUSH	W11
	PUSH	W12
	MOV	#163, W8
	MOV	#49887, W7
L_main0:
	DEC	W7
	BRA NZ	L_main0
	DEC	W8
	BRA NZ	L_main0
	NOP
	NOP
;BusPirate.c,91 :: 		debug = 0;                                                                  // set default amount of debug info
	CLR	W0
	MOV	W0, _debug
;BusPirate.c,92 :: 		CLKDIV = 0x0000;                                                            // 8MHz internal oscillator (fed to 4xPLL)
	CLR	CLKDIV
;BusPirate.c,93 :: 		AD1PCFG = 0xffff;                                                           // all digital
	MOV	#65535, W0
	MOV	WREG, AD1PCFG
;BusPirate.c,94 :: 		TRISA = 0x0000;
	CLR	TRISA
;BusPirate.c,95 :: 		TRISB = 0x0020;                                                             // bit 5 Rx in, rest output
	MOV	#32, W0
	MOV	WREG, TRISB
;BusPirate.c,96 :: 		LATA = 0;
	CLR	LATA
;BusPirate.c,97 :: 		LATB = 0;
	CLR	LATB
;BusPirate.c,98 :: 		VREGENABLE = 1;                                                             // turn on 3.3V and 5V
	BSET.B	LATAbits, #0
;BusPirate.c,99 :: 		for( ctr = 0 ; ctr < 8 ; ctr++){
; ctr start address is: 6 (W3)
	CLR	W3
; ctr end address is: 6 (W3)
L_main2:
; ctr start address is: 6 (W3)
	CP.B	W3, #8
	BRA LT	L__main134
	GOTO	L_main3
L__main134:
;BusPirate.c,100 :: 		upar[ctr] = 0UL;                                                        // initialise parameters
	SE	W3, W0
	SL	W0, #2, W1
	MOV	#lo_addr(_upar), W0
	ADD	W0, W1, W2
	CLR	W0
	CLR	W1
	MOV.D	W0, [W2]
;BusPirate.c,99 :: 		for( ctr = 0 ; ctr < 8 ; ctr++){
	INC.B	W3
;BusPirate.c,101 :: 		}
; ctr end address is: 6 (W3)
	GOTO	L_main2
L_main3:
;BusPirate.c,103 :: 		PPS_Mapping_NoLock(4, _OUTPUT, _U2TX);                                      // Sets RP4 to be Output, and maps EUSART2 Asynchronous Transmit/Synchronous Clock Output to it
	MOV.B	#5, W12
	CLR	W11
	MOV.B	#4, W10
	CALL	_PPS_Mapping_NoLock
;BusPirate.c,104 :: 		PPS_Mapping_NoLock(5, _INPUT, _U2RX);                                       // Sets RP5 to be Input, and maps RX2/DT2 Input to it
	MOV.B	#15, W12
	MOV.B	#1, W11
	MOV.B	#5, W10
	CALL	_PPS_Mapping_NoLock
;BusPirate.c,106 :: 		UART2_Init(9600);                                                           // Initialize UART module at 9600 bps
	MOV	#9600, W10
	MOV	#0, W11
	CALL	_UART2_Init
;BusPirate.c,107 :: 		Delay_ms(100);                                                              // Wait for UART module to stabilize
	MOV	#9, W8
	MOV	#9047, W7
L_main5:
	DEC	W7
	BRA NZ	L_main5
	DEC	W8
	BRA NZ	L_main5
;BusPirate.c,109 :: 		helptext();                                                                 // display initial help text
	CALL	_helptext
;BusPirate.c,111 :: 		while(1){
L_main7:
;BusPirate.c,112 :: 		UART2_Write_Text("\r\n>");
	MOV	#lo_addr(?lstr1_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,113 :: 		linein(inbuff);                                                         // wait for a line of text
	MOV	#lo_addr(_inbuff), W10
	CALL	_linein
;BusPirate.c,114 :: 		getparams(inbuff);                                                      // parse the text
	MOV	#lo_addr(_inbuff), W10
	CALL	_getparams
;BusPirate.c,116 :: 		if(debug > 0){                                                          // check if debug info wanted
	MOV	_debug, W0
	CP	W0, #0
	BRA GTU	L__main135
	GOTO	L_main9
L__main135:
;BusPirate.c,117 :: 		UART2_Write_Text("\r\nNumber of parameters = ");
	MOV	#lo_addr(?lstr2_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,118 :: 		PrintHex(nparams);
	MOV	_nparams, W10
	CALL	_PrintHex
;BusPirate.c,119 :: 		UART2_Write_Text("\r\nP0 = ");                                      // parameter 0 is command letter
	MOV	#lo_addr(?lstr3_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,120 :: 		UART2_Write(cmd);
	MOV	#lo_addr(_cmd), W0
	ZE	[W0], W10
	CALL	_UART2_Write
;BusPirate.c,121 :: 		UART2_Write_Text(" (Command)");
	MOV	#lo_addr(?lstr4_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,122 :: 		for( ctr = 1; ctr < 8 ; ctr++){                                     // remaining 7 parameters
; ctr start address is: 8 (W4)
	MOV.B	#1, W4
; ctr end address is: 8 (W4)
L_main10:
; ctr start address is: 8 (W4)
	CP.B	W4, #8
	BRA LT	L__main136
	GOTO	L_main11
L__main136:
;BusPirate.c,123 :: 		UART2_Write_Text("\r\nP");
	MOV	#lo_addr(?lstr5_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,124 :: 		UART2_Write(ctr + 48);                                          // write number as ASCII
	SE	W4, W1
	MOV	#48, W0
	ADD	W1, W0, W0
	MOV	W0, W10
	CALL	_UART2_Write
;BusPirate.c,125 :: 		UART2_Write_Text(" = ");
	MOV	#lo_addr(?lstr6_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,126 :: 		PrintHex(upar[ctr]);
	SE	W4, W0
	SL	W0, #2, W1
	MOV	#lo_addr(_upar), W0
	ADD	W0, W1, W0
	MOV.B	[W0], W10
	CALL	_PrintHex
;BusPirate.c,122 :: 		for( ctr = 1; ctr < 8 ; ctr++){                                     // remaining 7 parameters
	INC.B	W4
;BusPirate.c,127 :: 		}
; ctr end address is: 8 (W4)
	GOTO	L_main10
L_main11:
;BusPirate.c,128 :: 		}
L_main9:
;BusPirate.c,130 :: 		switch(cmd){
	GOTO	L_main13
;BusPirate.c,131 :: 		case '?':
L_main15:
;BusPirate.c,132 :: 		helptext();
	CALL	_helptext
;BusPirate.c,133 :: 		break;
	GOTO	L_main14
;BusPirate.c,134 :: 		case 'D':
L_main16:
;BusPirate.c,135 :: 		if(nparams > 1){
	MOV	_nparams, W0
	CP	W0, #1
	BRA GTU	L__main137
	GOTO	L_main17
L__main137:
;BusPirate.c,136 :: 		debug = upar[1];
	MOV	_upar+4, W0
	MOV	W0, _debug
;BusPirate.c,137 :: 		}
L_main17:
;BusPirate.c,138 :: 		break;
	GOTO	L_main14
;BusPirate.c,139 :: 		case 'N':
L_main18:
;BusPirate.c,140 :: 		command_n();
	CALL	_command_n
;BusPirate.c,141 :: 		break;
	GOTO	L_main14
;BusPirate.c,142 :: 		default:
L_main19:
;BusPirate.c,143 :: 		UART2_Write_Text("command not recognised\r\n");
	MOV	#lo_addr(?lstr7_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,144 :: 		break;
	GOTO	L_main14
;BusPirate.c,145 :: 		}
L_main13:
	MOV	#lo_addr(_cmd), W0
	MOV.B	[W0], W1
	MOV.B	#63, W0
	CP.B	W1, W0
	BRA NZ	L__main138
	GOTO	L_main15
L__main138:
	MOV	#lo_addr(_cmd), W0
	MOV.B	[W0], W1
	MOV.B	#68, W0
	CP.B	W1, W0
	BRA NZ	L__main139
	GOTO	L_main16
L__main139:
	MOV	#lo_addr(_cmd), W0
	MOV.B	[W0], W1
	MOV.B	#78, W0
	CP.B	W1, W0
	BRA NZ	L__main140
	GOTO	L_main18
L__main140:
	GOTO	L_main19
L_main14:
;BusPirate.c,146 :: 		}
	GOTO	L_main7
;BusPirate.c,147 :: 		}
L_end_main:
	POP	W12
	POP	W11
	POP	W10
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main

_command_n:

;BusPirate.c,150 :: 		void command_n(void){
;BusPirate.c,151 :: 		UART2_Write_Text("\r\nsend NEC IR message");
	PUSH	W10
	MOV	#lo_addr(?lstr8_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,152 :: 		NEC_out();
	CALL	_NEC_out
;BusPirate.c,153 :: 		}
L_end_command_n:
	POP	W10
	RETURN
; end of _command_n

_NEC_out:

;BusPirate.c,170 :: 		void NEC_out(void){
;BusPirate.c,173 :: 		IR_mark(173);                                                               // 9mS mark is 346 cycles of 38 kHz
	PUSH	W10
	MOV.B	#173, W10
	CALL	_IR_mark
;BusPirate.c,174 :: 		IR_mark(173);                                                               // but function only takes byte parameter
	MOV.B	#173, W10
	CALL	_IR_mark
;BusPirate.c,175 :: 		IR_space(173);                                                              // 4.5mS space is 173 cycles of 38 kHz
	MOV.B	#173, W10
	CALL	_IR_space
;BusPirate.c,176 :: 		NEC_byte_out(upar[1]);
	MOV	_upar+4, W10
	CALL	_NEC_byte_out
;BusPirate.c,177 :: 		NEC_byte_out(upar[2]);
	MOV	_upar+8, W10
	CALL	_NEC_byte_out
;BusPirate.c,178 :: 		NEC_byte_out(upar[3]);
	MOV	_upar+12, W10
	CALL	_NEC_byte_out
;BusPirate.c,179 :: 		NEC_byte_out(~upar[3]);                                                     // inverse of byte 3
	MOV	_upar+12, W0
	MOV	_upar+14, W1
	COM.B	W0
	MOV.B	W0, W10
	CALL	_NEC_byte_out
;BusPirate.c,180 :: 		NEC_one();                                                                  // stop bit of one
	CALL	_NEC_one
;BusPirate.c,182 :: 		ctr = (upar[4] & 0x0f);                                                     // maximum of 15 repeats
	MOV	_upar+16, W0
; ctr start address is: 0 (W0)
	AND.B	W0, #15, W0
; ctr end address is: 0 (W0)
	MOV.B	W0, W1
;BusPirate.c,183 :: 		while(ctr){                                                                 // parameter 4 is number of repeats
L_NEC_out20:
; ctr start address is: 2 (W1)
	CP0.B	W1
	BRA NZ	L__NEC_out144
	GOTO	L_NEC_out21
L__NEC_out144:
;BusPirate.c,184 :: 		NEC_repeat();                                                           // simple repeat sequence
	CALL	_NEC_repeat
;BusPirate.c,185 :: 		ctr--;
	DEC.B	W1
;BusPirate.c,186 :: 		}
; ctr end address is: 2 (W1)
	GOTO	L_NEC_out20
L_NEC_out21:
;BusPirate.c,187 :: 		}
L_end_NEC_out:
	POP	W10
	RETURN
; end of _NEC_out

_NEC_repeat:

;BusPirate.c,190 :: 		void NEC_repeat(void){
;BusPirate.c,191 :: 		Delay_ms(38);                                                               // must have a no-data period
	PUSH	W10
	MOV	#4, W8
	MOV	#6058, W7
L_NEC_repeat22:
	DEC	W7
	BRA NZ	L_NEC_repeat22
	DEC	W8
	BRA NZ	L_NEC_repeat22
	NOP
	NOP
;BusPirate.c,192 :: 		IR_mark(173);                                                               // 9mS mark is 346 cycles of 38 kHz
	MOV.B	#173, W10
	CALL	_IR_mark
;BusPirate.c,193 :: 		IR_mark(173);                                                               // but function only takes byte parameter
	MOV.B	#173, W10
	CALL	_IR_mark
;BusPirate.c,194 :: 		IR_space(87);                                                               // 2.25mS space is 87 cycles of 38 kHz
	MOV.B	#87, W10
	CALL	_IR_space
;BusPirate.c,195 :: 		NEC_one();                                                                  // stop bit of one
	CALL	_NEC_one
;BusPirate.c,196 :: 		}
L_end_NEC_repeat:
	POP	W10
	RETURN
; end of _NEC_repeat

_helptext:

;BusPirate.c,199 :: 		void helptext(void){
;BusPirate.c,200 :: 		UART2_Write_Text("\r\n?            help - 05 Nov 2018");
	PUSH	W10
	MOV	#lo_addr(?lstr9_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,201 :: 		UART2_Write_Text("\r\n             numbers in hex");
	MOV	#lo_addr(?lstr10_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,202 :: 		UART2_Write_Text("\r\n             omit number for no change\r\n");
	MOV	#lo_addr(?lstr11_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,203 :: 		UART2_Write_Text("\r\nd a          set debug level to a");
	MOV	#lo_addr(?lstr12_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,204 :: 		UART2_Write_Text("\r\nn aa aa dd r send NEC IR message hex");
	MOV	#lo_addr(?lstr13_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,205 :: 		UART2_Write_Text("\r\n");
	MOV	#lo_addr(?lstr14_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,206 :: 		}
L_end_helptext:
	POP	W10
	RETURN
; end of _helptext

_UART2_Write_Line:

;BusPirate.c,209 :: 		void UART2_Write_Line(char *uart_text) {
;BusPirate.c,210 :: 		UART2_Write_Text(uart_text);
	PUSH	W10
	CALL	_UART2_Write_Text
;BusPirate.c,211 :: 		UART2_Write_Text("\r\n");
	MOV	#lo_addr(?lstr15_BusPirate), W10
	CALL	_UART2_Write_Text
;BusPirate.c,212 :: 		}
L_end_UART2_Write_Line:
	POP	W10
	RETURN
; end of _UART2_Write_Line

_PrintHex:

;BusPirate.c,215 :: 		void PrintHex(unsigned char i) {
;BusPirate.c,218 :: 		hi = i & 0xF0;                                                              // high nibble
	PUSH	W10
	ZE	W10, W1
	MOV	#240, W0
	AND	W1, W0, W0
;BusPirate.c,219 :: 		hi = hi >> 4;
	ZE	W0, W0
	LSR	W0, #4, W0
;BusPirate.c,220 :: 		hi = hi + '0';
	ZE	W0, W1
	MOV	#48, W0
	ADD	W1, W0, W1
; hi start address is: 4 (W2)
	MOV.B	W1, W2
;BusPirate.c,221 :: 		if (hi > '9') hi = hi + 7;
	MOV.B	#57, W0
	CP.B	W1, W0
	BRA GTU	L__PrintHex149
	GOTO	L__PrintHex131
L__PrintHex149:
; hi start address is: 4 (W2)
	ADD.B	W2, #7, W2
; hi end address is: 4 (W2)
; hi end address is: 4 (W2)
	GOTO	L_PrintHex24
L__PrintHex131:
L_PrintHex24:
;BusPirate.c,222 :: 		lo = (i & 0x0F) + '0';                                                      // low nibble
; hi start address is: 4 (W2)
	ZE	W10, W0
	AND	W0, #15, W1
	MOV	#48, W0
	ADD	W1, W0, W1
; lo start address is: 6 (W3)
	MOV.B	W1, W3
;BusPirate.c,223 :: 		if (lo > '9') lo = lo + 7;
	MOV.B	#57, W0
	CP.B	W1, W0
	BRA GTU	L__PrintHex150
	GOTO	L__PrintHex132
L__PrintHex150:
; lo start address is: 0 (W0)
	ADD.B	W3, #7, W0
; lo end address is: 6 (W3)
; lo end address is: 0 (W0)
	GOTO	L_PrintHex25
L__PrintHex132:
	MOV.B	W3, W0
L_PrintHex25:
;BusPirate.c,225 :: 		UART2_Write(hi);
; lo start address is: 0 (W0)
	ZE	W2, W10
; hi end address is: 4 (W2)
	CALL	_UART2_Write
;BusPirate.c,226 :: 		UART2_Write(lo);
	ZE	W0, W10
; lo end address is: 0 (W0)
	CALL	_UART2_Write
;BusPirate.c,227 :: 		UART2_Write(' ');
	MOV	#32, W10
	CALL	_UART2_Write
;BusPirate.c,228 :: 		}
L_end_PrintHex:
	POP	W10
	RETURN
; end of _PrintHex

_getparams:
	LNK	#2

;BusPirate.c,231 :: 		char getparams(char* tempstring){
;BusPirate.c,236 :: 		unsigned int pointer1 = 0;                                                      // pointer within string
;BusPirate.c,237 :: 		unsigned int pointer2 = 0;                                                      // pointer within string
;BusPirate.c,239 :: 		oldcmd = cmd;                                                               // remember old value
	MOV	#lo_addr(_cmd), W0
; oldcmd start address is: 2 (W1)
	MOV.B	[W0], W1
;BusPirate.c,240 :: 		nparams = 0;                                                                // initialise
	CLR	W0
	MOV	W0, _nparams
;BusPirate.c,241 :: 		pointer1 = 0;                                                               // initialise
; pointer1 start address is: 4 (W2)
	CLR	W2
;BusPirate.c,243 :: 		for ( n = 0 ; n < 9 ; n++){                                                 // count 0 to 7
; n start address is: 0 (W0)
	CLR	W0
; n end address is: 0 (W0)
; pointer1 end address is: 4 (W2)
; oldcmd end address is: 2 (W1)
	MOV.B	W1, W3
	MOV	W0, W5
L_getparams26:
; n start address is: 10 (W5)
; pointer1 start address is: 4 (W2)
; oldcmd start address is: 6 (W3)
	CP	W5, #9
	BRA LT	L__getparams152
	GOTO	L__getparams129
L__getparams152:
;BusPirate.c,246 :: 		tempchar=1;                                                             // init
	MOV.B	#1, W0
	MOV.B	W0, [W14+0]
;BusPirate.c,247 :: 		do {
	GOTO	L_getparams29
L__getparams127:
;BusPirate.c,249 :: 		} while (tempchar == 0x20);
;BusPirate.c,247 :: 		do {
L_getparams29:
;BusPirate.c,248 :: 		tempchar = tempstring[pointer1++];
; oldcmd start address is: 6 (W3)
; oldcmd end address is: 6 (W3)
; pointer1 start address is: 4 (W2)
; n start address is: 10 (W5)
; n end address is: 10 (W5)
	ADD	W10, W2, W0
	MOV.B	[W0], W1
	MOV.B	W1, [W14+0]
	INC	W2
; pointer1 end address is: 4 (W2)
;BusPirate.c,249 :: 		} while (tempchar == 0x20);
	MOV.B	#32, W0
	CP.B	W1, W0
	BRA NZ	L__getparams153
	GOTO	L__getparams127
L__getparams153:
; oldcmd end address is: 6 (W3)
; pointer1 end address is: 4 (W2)
; n end address is: 10 (W5)
;BusPirate.c,250 :: 		pointer1--;                                                             // leave pointer after param
; pointer1 start address is: 14 (W7)
; n start address is: 10 (W5)
; pointer1 start address is: 4 (W2)
; oldcmd start address is: 6 (W3)
	SUB	W2, #1, W7
; pointer1 end address is: 4 (W2)
;BusPirate.c,253 :: 		if ((tempchar != 0) && (nparams < 8)){
	MOV.B	[W14+0], W0
	CP.B	W0, #0
	BRA NZ	L__getparams154
	GOTO	L__getparams109
L__getparams154:
	MOV	_nparams, W0
	CP	W0, #8
	BRA LTU	L__getparams155
	GOTO	L__getparams108
L__getparams155:
L__getparams107:
;BusPirate.c,254 :: 		nparams++;
	MOV	#1, W1
	MOV	#lo_addr(_nparams), W0
	ADD	W1, [W0], [W0]
;BusPirate.c,253 :: 		if ((tempchar != 0) && (nparams < 8)){
L__getparams109:
L__getparams108:
;BusPirate.c,257 :: 		if (n == 0){                                                            // only for param 0
	CP	W5, #0
	BRA Z	L__getparams156
	GOTO	L_getparams35
L__getparams156:
;BusPirate.c,258 :: 		tempchar = tempstring[pointer1];                                    // get only first letter
	ADD	W10, W7, W0
	MOV.B	[W0], W1
	MOV.B	W1, [W14+0]
;BusPirate.c,259 :: 		if ((tempchar > 0x60) && (tempchar < 0x7b)) {
	MOV.B	#96, W0
	CP.B	W1, W0
	BRA GTU	L__getparams157
	GOTO	L__getparams111
L__getparams157:
	MOV.B	[W14+0], W1
	MOV.B	#123, W0
	CP.B	W1, W0
	BRA LTU	L__getparams158
	GOTO	L__getparams110
L__getparams158:
L__getparams106:
;BusPirate.c,260 :: 		tempchar -= 0x20;                                               // to upper case
	MOV.B	[W14+0], W2
	MOV.B	#32, W1
	ADD	W14, #0, W0
	SUB.B	W2, W1, [W0]
;BusPirate.c,259 :: 		if ((tempchar > 0x60) && (tempchar < 0x7b)) {
L__getparams111:
L__getparams110:
;BusPirate.c,262 :: 		cmd=tempchar;
	MOV	#lo_addr(_cmd), W1
	MOV.B	[W14+0], W0
	MOV.B	W0, [W1]
;BusPirate.c,263 :: 		}
L_getparams35:
;BusPirate.c,265 :: 		tempchar=1;                                                             // initialise
	MOV.B	#1, W0
	MOV.B	W0, [W14+0]
;BusPirate.c,266 :: 		if (nparams != 0){                                                      // only for non-blank line
	MOV	_nparams, W0
	CP	W0, #0
	BRA NZ	L__getparams159
	GOTO	L__getparams128
L__getparams159:
;BusPirate.c,268 :: 		pointer2=0;                                                         // initialise
; pointer2 start address is: 8 (W4)
	CLR	W4
; oldcmd end address is: 6 (W3)
; pointer2 end address is: 8 (W4)
; n end address is: 10 (W5)
; pointer1 end address is: 14 (W7)
	MOV	W7, W2
	MOV	W5, W7
	MOV.B	W3, W5
;BusPirate.c,269 :: 		do {
L_getparams40:
;BusPirate.c,270 :: 		tempchar = tempstring[pointer1++];                              // get char
; oldcmd start address is: 10 (W5)
; pointer1 start address is: 16 (W8)
; n start address is: 14 (W7)
; pointer2 start address is: 8 (W4)
; pointer1 start address is: 4 (W2)
; n start address is: 14 (W7)
; n end address is: 14 (W7)
; oldcmd start address is: 10 (W5)
; oldcmd end address is: 10 (W5)
	ADD	W10, W2, W0
	MOV.B	[W0], W1
	MOV.B	W1, [W14+0]
; pointer1 start address is: 16 (W8)
	ADD	W2, #1, W8
; pointer1 end address is: 4 (W2)
; pointer1 end address is: 16 (W8)
;BusPirate.c,271 :: 		if ((tempchar > 0x60) && (tempchar < 0x7b)) {
	MOV.B	#96, W0
	CP.B	W1, W0
	BRA GTU	L__getparams160
	GOTO	L__getparams113
L__getparams160:
; n end address is: 14 (W7)
; pointer1 end address is: 16 (W8)
; oldcmd end address is: 10 (W5)
; oldcmd start address is: 10 (W5)
; pointer1 start address is: 16 (W8)
; n start address is: 14 (W7)
	MOV.B	[W14+0], W1
	MOV.B	#123, W0
	CP.B	W1, W0
	BRA LTU	L__getparams161
	GOTO	L__getparams112
L__getparams161:
L__getparams105:
;BusPirate.c,272 :: 		tempchar -= 0x20;                                           // to upper case
	MOV.B	[W14+0], W2
	MOV.B	#32, W1
	ADD	W14, #0, W0
	SUB.B	W2, W1, [W0]
;BusPirate.c,271 :: 		if ((tempchar > 0x60) && (tempchar < 0x7b)) {
L__getparams113:
L__getparams112:
;BusPirate.c,274 :: 		param[n][pointer2++] = tempchar;                                // and store it
	MOV	#20, W0
	MUL.UU	W0, W7, W2
	MOV	#lo_addr(_param), W0
	ADD	W0, W2, W0
	ADD	W0, W4, W1
	MOV.B	[W14+0], W0
	MOV.B	W0, [W1]
; pointer2 start address is: 12 (W6)
	ADD	W4, #1, W6
; pointer2 end address is: 8 (W4)
;BusPirate.c,275 :: 		} while ((tempchar > 0x20) && (tempchar < 0x7f) && (pointer2 < 20));   // text
	MOV.B	[W14+0], W1
	MOV.B	#32, W0
	CP.B	W1, W0
	BRA GTU	L__getparams162
	GOTO	L__getparams116
L__getparams162:
	MOV.B	[W14+0], W1
	MOV.B	#127, W0
	CP.B	W1, W0
	BRA LTU	L__getparams163
	GOTO	L__getparams115
L__getparams163:
	CP	W6, #20
	BRA LTU	L__getparams164
	GOTO	L__getparams114
L__getparams164:
	MOV	W8, W2
	MOV	W6, W4
	GOTO	L_getparams40
L__getparams116:
L__getparams115:
L__getparams114:
;BusPirate.c,276 :: 		param[n][pointer2-1] = 0;                                           // zero terminate param string
	MOV	#20, W0
	MUL.UU	W0, W7, W2
	MOV	#lo_addr(_param), W0
	ADD	W0, W2, W1
	SUB	W6, #1, W0
; pointer2 end address is: 12 (W6)
	ADD	W1, W0, W1
	CLR	W0
	MOV.B	W0, [W1]
;BusPirate.c,277 :: 		if((tempchar == 0) || (n ==9 )){                                    // no more params if end of line
	MOV.B	[W14+0], W0
	CP.B	W0, #0
	BRA NZ	L__getparams165
	GOTO	L__getparams118
L__getparams165:
	CP	W7, #9
	BRA NZ	L__getparams166
	GOTO	L__getparams117
L__getparams166:
	GOTO	L_getparams50
; n end address is: 14 (W7)
; pointer1 end address is: 16 (W8)
L__getparams118:
L__getparams117:
;BusPirate.c,278 :: 		break;
	GOTO	L_getparams27
;BusPirate.c,279 :: 		}
L_getparams50:
;BusPirate.c,280 :: 		}
; pointer1 start address is: 16 (W8)
; n start address is: 14 (W7)
	MOV.B	W5, W1
; pointer1 end address is: 16 (W8)
; oldcmd end address is: 10 (W5)
	MOV	W7, W2
	MOV	W8, W0
	GOTO	L_getparams39
; n end address is: 14 (W7)
L__getparams128:
;BusPirate.c,266 :: 		if (nparams != 0){                                                      // only for non-blank line
	MOV	W7, W0
	MOV	W5, W2
	MOV.B	W3, W1
;BusPirate.c,280 :: 		}
L_getparams39:
;BusPirate.c,243 :: 		for ( n = 0 ; n < 9 ; n++){                                                 // count 0 to 7
; pointer1 start address is: 0 (W0)
; n start address is: 4 (W2)
; oldcmd start address is: 2 (W1)
; n start address is: 10 (W5)
	ADD	W2, #1, W5
; n end address is: 4 (W2)
;BusPirate.c,281 :: 		}
	MOV.B	W1, W3
; pointer1 end address is: 0 (W0)
; oldcmd end address is: 2 (W1)
; n end address is: 10 (W5)
	MOV	W0, W2
	GOTO	L_getparams26
L__getparams129:
;BusPirate.c,243 :: 		for ( n = 0 ; n < 9 ; n++){                                                 // count 0 to 7
	MOV.B	W3, W5
;BusPirate.c,281 :: 		}
L_getparams27:
;BusPirate.c,284 :: 		for (n = 0; n < nparams ; n++){                                             // parms are 0 to 7
; oldcmd start address is: 10 (W5)
; n start address is: 12 (W6)
	CLR	W6
; oldcmd end address is: 10 (W5)
; n end address is: 12 (W6)
L_getparams51:
; n start address is: 12 (W6)
; oldcmd start address is: 10 (W5)
	MOV	#lo_addr(_nparams), W0
	CP	W6, [W0]
	BRA LTU	L__getparams167
	GOTO	L_getparams52
L__getparams167:
;BusPirate.c,287 :: 		pointer1 = 0;                                                           // initialise
; pointer1 start address is: 6 (W3)
	CLR	W3
;BusPirate.c,288 :: 		upar[n] = 0;                                                            // initialise
	SL	W6, #2, W1
	MOV	#lo_addr(_upar), W0
	ADD	W0, W1, W2
	CLR	W0
	CLR	W1
	MOV.D	W0, [W2]
; pointer1 end address is: 6 (W3)
; n end address is: 12 (W6)
	MOV	W3, W1
;BusPirate.c,289 :: 		do {
	GOTO	L_getparams54
L__getparams130:
;BusPirate.c,308 :: 		} while (tempchar2 != 0);
	MOV	W7, W1
;BusPirate.c,289 :: 		do {
L_getparams54:
;BusPirate.c,290 :: 		tempchar = param[n][pointer1++];                                    // read one character
; pointer1 start address is: 14 (W7)
; pointer1 start address is: 2 (W1)
; oldcmd start address is: 10 (W5)
; oldcmd end address is: 10 (W5)
; n start address is: 12 (W6)
	MOV	#20, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_param), W0
	ADD	W0, W2, W0
	ADD	W0, W1, W0
	MOV.B	[W0], W0
	MOV.B	W0, [W14+0]
; pointer1 start address is: 14 (W7)
	ADD	W1, #1, W7
; pointer1 end address is: 2 (W1)
; pointer1 end address is: 14 (W7)
;BusPirate.c,291 :: 		if ( tempchar != 0 ){
	CP.B	W0, #0
	BRA NZ	L__getparams168
	GOTO	L_getparams57
L__getparams168:
; oldcmd end address is: 10 (W5)
; pointer1 end address is: 14 (W7)
;BusPirate.c,292 :: 		upar[n] = upar[n] * 0x10;                                       // next most signicant hex digit
; pointer1 start address is: 14 (W7)
; oldcmd start address is: 10 (W5)
	SL	W6, #2, W1
	MOV	#lo_addr(_upar), W0
	ADD	W0, W1, W4
	MOV.D	[W4], W2
	SL	W3, #4, W1
	LSR	W2, #12, W0
	IOR	W0, W1, W1
	SL	W2, #4, W0
	MOV.D	W0, [W4]
;BusPirate.c,293 :: 		}
L_getparams57:
;BusPirate.c,294 :: 		tempchar2 = tempchar;                                               // remember original character
; tempchar2 start address is: 16 (W8)
	MOV.B	[W14+0], W8
;BusPirate.c,295 :: 		if ((tempchar < 0x30) || (tempchar > 0x46)) {
	MOV.B	[W14+0], W1
	MOV.B	#48, W0
	CP.B	W1, W0
	BRA GEU	L__getparams169
	GOTO	L__getparams120
L__getparams169:
	MOV.B	[W14+0], W1
	MOV.B	#70, W0
	CP.B	W1, W0
	BRA LEU	L__getparams170
	GOTO	L__getparams119
L__getparams170:
	GOTO	L_getparams60
L__getparams120:
L__getparams119:
;BusPirate.c,296 :: 		tempchar = 0x00;                                                // non-hex to zero
	CLR	W0
	MOV.B	W0, [W14+0]
;BusPirate.c,297 :: 		}
L_getparams60:
;BusPirate.c,298 :: 		if ((tempchar > 0x39) && (tempchar < 0x41)) {
	MOV.B	[W14+0], W1
	MOV.B	#57, W0
	CP.B	W1, W0
	BRA GTU	L__getparams171
	GOTO	L__getparams122
L__getparams171:
	MOV.B	[W14+0], W1
	MOV.B	#65, W0
	CP.B	W1, W0
	BRA LTU	L__getparams172
	GOTO	L__getparams121
L__getparams172:
L__getparams101:
;BusPirate.c,299 :: 		tempchar = 0x00;                                                // non-hex to zero
	CLR	W0
	MOV.B	W0, [W14+0]
;BusPirate.c,298 :: 		if ((tempchar > 0x39) && (tempchar < 0x41)) {
L__getparams122:
L__getparams121:
;BusPirate.c,301 :: 		if ((tempchar > 0x40) && (tempchar < 0x47)) {
	MOV.B	[W14+0], W1
	MOV.B	#64, W0
	CP.B	W1, W0
	BRA GTU	L__getparams173
	GOTO	L__getparams124
L__getparams173:
	MOV.B	[W14+0], W1
	MOV.B	#71, W0
	CP.B	W1, W0
	BRA LTU	L__getparams174
	GOTO	L__getparams123
L__getparams174:
L__getparams100:
;BusPirate.c,302 :: 		tempchar -= 0x37;                                               // to bin
	MOV.B	#55, W1
	ADD	W14, #0, W0
	SUBR.B	W1, [W0], [W0]
;BusPirate.c,301 :: 		if ((tempchar > 0x40) && (tempchar < 0x47)) {
L__getparams124:
L__getparams123:
;BusPirate.c,304 :: 		if ((tempchar > 0x2f) && (tempchar < 0x3a)) {
	MOV.B	[W14+0], W1
	MOV.B	#47, W0
	CP.B	W1, W0
	BRA GTU	L__getparams175
	GOTO	L__getparams126
L__getparams175:
	MOV.B	[W14+0], W1
	MOV.B	#58, W0
	CP.B	W1, W0
	BRA LTU	L__getparams176
	GOTO	L__getparams125
L__getparams176:
L__getparams99:
;BusPirate.c,305 :: 		tempchar -= 0x30;                                               // to bin
	MOV.B	#48, W1
	ADD	W14, #0, W0
	SUBR.B	W1, [W0], [W0]
;BusPirate.c,304 :: 		if ((tempchar > 0x2f) && (tempchar < 0x3a)) {
L__getparams126:
L__getparams125:
;BusPirate.c,307 :: 		upar[n] += tempchar;
	SL	W6, #2, W1
	MOV	#lo_addr(_upar), W0
	ADD	W0, W1, W4
	ADD	W14, #0, W0
	ZE	[W0], W2
	CLR	W3
	ADD	W2, [W4++], W0
	ADDC	W3, [W4--], W1
	MOV.D	W0, [W4]
;BusPirate.c,308 :: 		} while (tempchar2 != 0);
	CP.B	W8, #0
	BRA Z	L__getparams177
	GOTO	L__getparams130
L__getparams177:
; pointer1 end address is: 14 (W7)
; tempchar2 end address is: 16 (W8)
;BusPirate.c,284 :: 		for (n = 0; n < nparams ; n++){                                             // parms are 0 to 7
; n start address is: 12 (W6)
	INC	W6
; n end address is: 12 (W6)
;BusPirate.c,310 :: 		}
; n end address is: 12 (W6)
	GOTO	L_getparams51
L_getparams52:
;BusPirate.c,312 :: 		if (nparams == 0) {
	MOV	_nparams, W0
	CP	W0, #0
	BRA Z	L__getparams178
	GOTO	L_getparams70
L__getparams178:
;BusPirate.c,313 :: 		cmd = oldcmd;
	MOV	#lo_addr(_cmd), W0
	MOV.B	W5, [W0]
; oldcmd end address is: 10 (W5)
;BusPirate.c,314 :: 		}
L_getparams70:
;BusPirate.c,315 :: 		return cmd;
	MOV	#lo_addr(_cmd), W0
	MOV.B	[W0], W0
;BusPirate.c,316 :: 		}
L_end_getparams:
	ULNK
	RETURN
; end of _getparams

_linein:

;BusPirate.c,319 :: 		void linein(char* pstring){
;BusPirate.c,320 :: 		char inChar=0;
; inChar start address is: 2 (W1)
	CLR	W1
; inChar end address is: 2 (W1)
;BusPirate.c,322 :: 		while(inChar != '\r'){
L_linein71:
; inChar start address is: 2 (W1)
	CP.B	W1, #13
	BRA NZ	L__linein180
	GOTO	L_linein72
L__linein180:
;BusPirate.c,324 :: 		if (UART2_Data_Ready()){                                                //UART read
	CALL	_UART2_Data_Ready
	CP0	W0
	BRA NZ	L__linein181
	GOTO	L__linein98
L__linein181:
; inChar end address is: 2 (W1)
;BusPirate.c,325 :: 		inChar = UART2_Read();
	CALL	_UART2_Read
; inChar start address is: 2 (W1)
	MOV.B	W0, W1
;BusPirate.c,326 :: 		UART2_Write(inChar);
	PUSH	W10
	ZE	W0, W10
	CALL	_UART2_Write
	POP	W10
;BusPirate.c,327 :: 		if(inChar == '\r'){
	CP.B	W1, #13
	BRA Z	L__linein182
	GOTO	L_linein74
L__linein182:
;BusPirate.c,328 :: 		UART2_Write('\n');
	PUSH	W10
	MOV	#10, W10
	CALL	_UART2_Write
	POP	W10
;BusPirate.c,329 :: 		*pstring++ = '\0';
	CLR	W0
	MOV.B	W0, [W10]
	ADD	W10, #1, W0
	MOV	W0, W10
;BusPirate.c,330 :: 		}
	GOTO	L_linein75
L_linein74:
;BusPirate.c,332 :: 		if (inChar != 0x7f ){                                           // if not backspace
	MOV.B	#127, W0
	CP.B	W1, W0
	BRA NZ	L__linein183
	GOTO	L_linein76
L__linein183:
;BusPirate.c,333 :: 		*pstring++ = inChar;
	MOV.B	W1, [W10]
	ADD	W10, #1, W0
	MOV	W0, W10
;BusPirate.c,334 :: 		}
L_linein76:
;BusPirate.c,335 :: 		if (inChar == 0x7f ){                                           //handle backspace
	MOV.B	#127, W0
	CP.B	W1, W0
	BRA Z	L__linein184
	GOTO	L_linein77
L__linein184:
;BusPirate.c,336 :: 		*--pstring = 0x00;
	SUB	W10, #1, W0
	MOV	W0, W10
	CLR	W0
	MOV.B	W0, [W10]
;BusPirate.c,337 :: 		}
L_linein77:
;BusPirate.c,338 :: 		}
L_linein75:
;BusPirate.c,339 :: 		}// End of if (UART"IsPressed()){...
	GOTO	L_linein73
; inChar end address is: 2 (W1)
L__linein98:
;BusPirate.c,324 :: 		if (UART2_Data_Ready()){                                                //UART read
;BusPirate.c,339 :: 		}// End of if (UART"IsPressed()){...
L_linein73:
;BusPirate.c,340 :: 		}// end of while..
; inChar start address is: 2 (W1)
; inChar end address is: 2 (W1)
	GOTO	L_linein71
L_linein72:
;BusPirate.c,341 :: 		}
L_end_linein:
	RETURN
; end of _linein

_chin:

;BusPirate.c,344 :: 		unsigned char chin(void){
;BusPirate.c,347 :: 		while(!UART2_Data_Ready());
L_chin78:
	CALL	_UART2_Data_Ready
	CP0	W0
	BRA Z	L__chin186
	GOTO	L_chin79
L__chin186:
	GOTO	L_chin78
L_chin79:
;BusPirate.c,348 :: 		temp=UART2_Read();
	CALL	_UART2_Read
;BusPirate.c,349 :: 		return temp;
;BusPirate.c,350 :: 		}
L_end_chin:
	RETURN
; end of _chin

_chout:

;BusPirate.c,353 :: 		void chout(unsigned char outchar){
;BusPirate.c,355 :: 		UART2_Write(outchar);
	PUSH	W10
	ZE	W10, W10
	CALL	_UART2_Write
;BusPirate.c,356 :: 		if(outchar == 0x0d){
	CP.B	W10, #13
	BRA Z	L__chout188
	GOTO	L_chout80
L__chout188:
;BusPirate.c,357 :: 		UART2_Write(0x0a);
	MOV	#10, W10
	CALL	_UART2_Write
;BusPirate.c,358 :: 		}
L_chout80:
;BusPirate.c,359 :: 		}
L_end_chout:
	POP	W10
	RETURN
; end of _chout

_NEC_byte_out:

;BusPirate.c,363 :: 		void NEC_byte_out(unsigned char send_char){
;BusPirate.c,366 :: 		for(n=0 ; n<8 ; n++){                                                       // count through 8 bits, bit 0 sent first
; n start address is: 4 (W2)
	CLR	W2
; n end address is: 4 (W2)
L_NEC_byte_out81:
; n start address is: 4 (W2)
	CP.B	W2, #8
	BRA LTU	L__NEC_byte_out190
	GOTO	L_NEC_byte_out82
L__NEC_byte_out190:
;BusPirate.c,367 :: 		if(send_char & (1 << n)){                                               // check bit(n) value
	ZE	W2, W1
	MOV	#1, W0
	SL	W0, W1, W1
	ZE	W10, W0
	AND	W0, W1, W0
	BRA NZ	L__NEC_byte_out191
	GOTO	L_NEC_byte_out84
L__NEC_byte_out191:
;BusPirate.c,368 :: 		NEC_one();                                                           // send a one to IR
	PUSH	W10
	CALL	_NEC_one
	POP	W10
;BusPirate.c,369 :: 		}
	GOTO	L_NEC_byte_out85
L_NEC_byte_out84:
;BusPirate.c,371 :: 		NEC_zero();                                                          // send a zero to IR
	PUSH	W10
	CALL	_NEC_zero
	POP	W10
;BusPirate.c,372 :: 		}   }
L_NEC_byte_out85:
;BusPirate.c,366 :: 		for(n=0 ; n<8 ; n++){                                                       // count through 8 bits, bit 0 sent first
	INC.B	W2
;BusPirate.c,372 :: 		}   }
; n end address is: 4 (W2)
	GOTO	L_NEC_byte_out81
L_NEC_byte_out82:
;BusPirate.c,373 :: 		}
L_end_NEC_byte_out:
	RETURN
; end of _NEC_byte_out

_NEC_one:

;BusPirate.c,377 :: 		void NEC_one(){
;BusPirate.c,378 :: 		IR_mark(21);
	PUSH	W10
	MOV.B	#21, W10
	CALL	_IR_mark
;BusPirate.c,379 :: 		IR_space(63);                                                               // adjust to give correct rate
	MOV.B	#63, W10
	CALL	_IR_space
;BusPirate.c,380 :: 		}
L_end_NEC_one:
	POP	W10
	RETURN
; end of _NEC_one

_NEC_zero:

;BusPirate.c,384 :: 		void NEC_zero(){                                                                // adjust to give correct rate
;BusPirate.c,385 :: 		IR_mark(21);
	PUSH	W10
	MOV.B	#21, W10
	CALL	_IR_mark
;BusPirate.c,386 :: 		IR_space(21);                                                               //
	MOV.B	#21, W10
	CALL	_IR_space
;BusPirate.c,387 :: 		}
L_end_NEC_zero:
	POP	W10
	RETURN
; end of _NEC_zero

_IR_mark:

;BusPirate.c,393 :: 		void IR_mark(unsigned char n_cycles){
;BusPirate.c,394 :: 		while(n_cycles){
L_IR_mark86:
	CP0.B	W10
	BRA NZ	L__IR_mark195
	GOTO	L_IR_mark87
L__IR_mark195:
;BusPirate.c,395 :: 		ir_out = 1;                                // high to turn on IR LED
	BSET	LATBbits, #10
;BusPirate.c,396 :: 		Delay_us(13);                              // half of 38kHz square wave
	MOV	#69, W7
L_IR_mark88:
	DEC	W7
	BRA NZ	L_IR_mark88
	NOP
;BusPirate.c,397 :: 		ir_out = 0;                                // low to turn off IR LED
	BCLR	LATBbits, #10
;BusPirate.c,398 :: 		Delay_us(13);                              // half of 38kHz square wave
	MOV	#69, W7
L_IR_mark90:
	DEC	W7
	BRA NZ	L_IR_mark90
	NOP
;BusPirate.c,399 :: 		n_cycles--;
	SUB.B	W10, #1, W0
	MOV.B	W0, W10
;BusPirate.c,400 :: 		}
	GOTO	L_IR_mark86
L_IR_mark87:
;BusPirate.c,401 :: 		}
L_end_IR_mark:
	RETURN
; end of _IR_mark

_IR_space:

;BusPirate.c,405 :: 		void IR_space(unsigned char n_cycles){
;BusPirate.c,406 :: 		while(n_cycles){
L_IR_space92:
	CP0.B	W10
	BRA NZ	L__IR_space197
	GOTO	L_IR_space93
L__IR_space197:
;BusPirate.c,407 :: 		ir_out = 0;                                // low to turn off IR LED
	BCLR	LATBbits, #10
;BusPirate.c,408 :: 		Delay_us(13);                              // half of 38kHz square wave
	MOV	#69, W7
L_IR_space94:
	DEC	W7
	BRA NZ	L_IR_space94
	NOP
;BusPirate.c,409 :: 		ir_out = 0;                                // low to turn off IR LED
	BCLR	LATBbits, #10
;BusPirate.c,410 :: 		Delay_us(13);                              // half of 38kHz square wave
	MOV	#69, W7
L_IR_space96:
	DEC	W7
	BRA NZ	L_IR_space96
	NOP
;BusPirate.c,411 :: 		n_cycles--;
	SUB.B	W10, #1, W0
	MOV.B	W0, W10
;BusPirate.c,412 :: 		}
	GOTO	L_IR_space92
L_IR_space93:
;BusPirate.c,413 :: 		}
L_end_IR_space:
	RETURN
; end of _IR_space
