#line 1 "C:/PIC/MikroC/PIC24/PIC24F64GA002/BusPirate/BusPirate.c"
#line 60 "C:/PIC/MikroC/PIC24/PIC24F64GA002/BusPirate/BusPirate.c"
sbit VREGENABLE at LATAbits.B0;
sbit LD1 at LATAbits.B1;
sbit ir_out at LATBbits.B10;


void command_n(void);
void linein(char* pstring);
char getparams(char* tempstring);
void PrintHex(unsigned char i);
void helptext(void);
void NEC_zero();
void NEC_one();
void IR_mark(unsigned char n_cycles);
void IR_space(unsigned char n_cycles);
void NEC_byte_out(unsigned char send_char);
void NEC_out(void);
void NEC_repeat(void);


unsigned char inbuff[257];
unsigned char cmd;
unsigned char param[8][20];
unsigned long upar[8];
unsigned int nparams;
unsigned debug;


void main() {
signed char ctr;

 Delay_ms(2000);
 debug = 0;
 CLKDIV = 0x0000;
 AD1PCFG = 0xffff;
 TRISA = 0x0000;
 TRISB = 0x0020;
 LATA = 0;
 LATB = 0;
 VREGENABLE = 1;
 for( ctr = 0 ; ctr < 8 ; ctr++){
 upar[ctr] = 0UL;
 }

 PPS_Mapping_NoLock(4, _OUTPUT, _U2TX);
 PPS_Mapping_NoLock(5, _INPUT, _U2RX);

 UART2_Init(9600);
 Delay_ms(100);

 helptext();

 while(1){
 UART2_Write_Text("\r\n>");
 linein(inbuff);
 getparams(inbuff);

 if(debug > 0){
 UART2_Write_Text("\r\nNumber of parameters = ");
 PrintHex(nparams);
 UART2_Write_Text("\r\nP0 = ");
 UART2_Write(cmd);
 UART2_Write_Text(" (Command)");
 for( ctr = 1; ctr < 8 ; ctr++){
 UART2_Write_Text("\r\nP");
 UART2_Write(ctr + 48);
 UART2_Write_Text(" = ");
 PrintHex(upar[ctr]);
 }
 }

 switch(cmd){
 case '?':
 helptext();
 break;
 case 'D':
 if(nparams > 1){
 debug = upar[1];
 }
 break;
 case 'N':
 command_n();
 break;
 default:
 UART2_Write_Text("command not recognised\r\n");
 break;
 }
 }
}


void command_n(void){
 UART2_Write_Text("\r\nsend NEC IR message");
 NEC_out();
}
#line 170 "C:/PIC/MikroC/PIC24/PIC24F64GA002/BusPirate/BusPirate.c"
void NEC_out(void){
signed char ctr;

 IR_mark(173);
 IR_mark(173);
 IR_space(173);
 NEC_byte_out(upar[1]);
 NEC_byte_out(upar[2]);
 NEC_byte_out(upar[3]);
 NEC_byte_out(~upar[3]);
 NEC_one();

 ctr = (upar[4] & 0x0f);
 while(ctr){
 NEC_repeat();
 ctr--;
 }
}


void NEC_repeat(void){
 Delay_ms(38);
 IR_mark(173);
 IR_mark(173);
 IR_space(87);
 NEC_one();
}


void helptext(void){
 UART2_Write_Text("\r\n?            help - 05 Nov 2018");
 UART2_Write_Text("\r\n             numbers in hex");
 UART2_Write_Text("\r\n             omit number for no change\r\n");
 UART2_Write_Text("\r\nd a          set debug level to a");
 UART2_Write_Text("\r\nn aa aa dd r send NEC IR message hex");
 UART2_Write_Text("\r\n");
}


void UART2_Write_Line(char *uart_text) {
 UART2_Write_Text(uart_text);
 UART2_Write_Text("\r\n");
}


void PrintHex(unsigned char i) {
unsigned char hi,lo;

 hi = i & 0xF0;
 hi = hi >> 4;
 hi = hi + '0';
 if (hi > '9') hi = hi + 7;
 lo = (i & 0x0F) + '0';
 if (lo > '9') lo = lo + 7;

 UART2_Write(hi);
 UART2_Write(lo);
 UART2_Write(' ');
}


char getparams(char* tempstring){
char oldcmd;
int n;
unsigned char tempchar;
unsigned char tempchar2;
unsigned int pointer1 = 0;
unsigned int pointer2 = 0;

 oldcmd = cmd;
 nparams = 0;
 pointer1 = 0;

 for ( n = 0 ; n < 9 ; n++){


 tempchar=1;
 do {
 tempchar = tempstring[pointer1++];
 } while (tempchar == 0x20);
 pointer1--;


 if ((tempchar != 0) && (nparams < 8)){
 nparams++;
 }

 if (n == 0){
 tempchar = tempstring[pointer1];
 if ((tempchar > 0x60) && (tempchar < 0x7b)) {
 tempchar -= 0x20;
 }
 cmd=tempchar;
 }

 tempchar=1;
 if (nparams != 0){

 pointer2=0;
 do {
 tempchar = tempstring[pointer1++];
 if ((tempchar > 0x60) && (tempchar < 0x7b)) {
 tempchar -= 0x20;
 }
 param[n][pointer2++] = tempchar;
 } while ((tempchar > 0x20) && (tempchar < 0x7f) && (pointer2 < 20));
 param[n][pointer2-1] = 0;
 if((tempchar == 0) || (n ==9 )){
 break;
 }
 }
 }


 for (n = 0; n < nparams ; n++){

 tempchar2 = 1;
 pointer1 = 0;
 upar[n] = 0;
 do {
 tempchar = param[n][pointer1++];
 if ( tempchar != 0 ){
 upar[n] = upar[n] * 0x10;
 }
 tempchar2 = tempchar;
 if ((tempchar < 0x30) || (tempchar > 0x46)) {
 tempchar = 0x00;
 }
 if ((tempchar > 0x39) && (tempchar < 0x41)) {
 tempchar = 0x00;
 }
 if ((tempchar > 0x40) && (tempchar < 0x47)) {
 tempchar -= 0x37;
 }
 if ((tempchar > 0x2f) && (tempchar < 0x3a)) {
 tempchar -= 0x30;
 }
 upar[n] += tempchar;
 } while (tempchar2 != 0);

 }

 if (nparams == 0) {
 cmd = oldcmd;
 }
 return cmd;
}


void linein(char* pstring){
char inChar=0;

 while(inChar != '\r'){

 if (UART2_Data_Ready()){
 inChar = UART2_Read();
 UART2_Write(inChar);
 if(inChar == '\r'){
 UART2_Write('\n');
 *pstring++ = '\0';
 }
 else {
 if (inChar != 0x7f ){
 *pstring++ = inChar;
 }
 if (inChar == 0x7f ){
 *--pstring = 0x00;
 }
 }
 }
 }
}


unsigned char chin(void){
unsigned char temp;

 while(!UART2_Data_Ready());
 temp=UART2_Read();
 return temp;
}


void chout(unsigned char outchar){

 UART2_Write(outchar);
 if(outchar == 0x0d){
 UART2_Write(0x0a);
 }
}



void NEC_byte_out(unsigned char send_char){
unsigned char n;

 for(n=0 ; n<8 ; n++){
 if(send_char & (1 << n)){
 NEC_one();
 }
 else{
 NEC_zero();
 } }
}



void NEC_one(){
 IR_mark(21);
 IR_space(63);
}



void NEC_zero(){
 IR_mark(21);
 IR_space(21);
}





void IR_mark(unsigned char n_cycles){
 while(n_cycles){
 ir_out = 1;
 Delay_us(13);
 ir_out = 0;
 Delay_us(13);
 n_cycles--;
 }
}



void IR_space(unsigned char n_cycles){
 while(n_cycles){
 ir_out = 0;
 Delay_us(13);
 ir_out = 0;
 Delay_us(13);
 n_cycles--;
 }
}
